package com.erusev.control.a2
{
	import com.erusev.core.Shape_;
	
	import flash.display.Sprite;
	
	public class PlayheadController extends Shape_
	{
		public function PlayheadController()
		{
			super();
			
			useHandCursor = true;
			buttonMode = true;
			mouseChildren = false;
			
			track = new Sprite();
			addChild(track);
			
			playhead = new Sprite();
			addChild(playhead);
			
			mask_ = new Sprite();
			addChild(mask_);
			
			track.mask = mask_;
		}
		
		// objects
		
		private var track:Sprite;
		private var playhead:Sprite;
		private var mask_:Sprite;
		
		// properties
		
		private var _playheadColor:Number;
		
		public function set playheadColor(value:Number):void
		{
			_playheadColor = value;
			
			draw();
		}
		
		// playheadProgress
		
		private var _playheadProgress:Number = 0;
		
		public function set playheadProgress(value:Number):void
		{
			_playheadProgress = value;
			
			draw();
		}
		
		// loadProgress
		
		private var _loadProgress:Number = 0;
		
		public function set loadProgress(value:Number):void
		{
			_loadProgress = value;
			
			draw();
		}
		
		override protected function draw():void
		{
			graphics.clear();
			graphics.beginFill(0, 0);
			graphics.drawRect(0, 0, _width, _height);
			
			mask_.graphics.clear();
			mask_.graphics.beginFill(0);
			mask_.graphics.drawRect(0, 0, int(_playheadProgress*_width) - 1, _height);
			mask_.graphics.drawRect(int(_playheadProgress*_width) + 2, 0, _width - int(_playheadProgress*_width), _height);
			
			track.graphics.clear();
			
			track.graphics.beginFill(_color, .25);
			track.graphics.drawRect(0, 5, _width, 1);
			
			track.graphics.beginFill(_color);
			track.graphics.drawRect(0, 5, int(_loadProgress*_width), 1);
			
			track.graphics.beginFill(_playheadColor);
			track.graphics.drawRect(0, 5, int(_playheadProgress*_width), 1);
			
			playhead.graphics.clear();
			playhead.graphics.beginFill(_playheadColor);
			playhead.graphics.drawRect(int(_playheadProgress*_width), 0, 1, 11);
		}
	}
}