package com.erusev.core
{
	import flash.display.LoaderInfo;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	
	public class SWFComponent extends Sprite
	{
		private var component:Sprite;
		
		public function SWFComponent(class_:Class)
		{
			super();
			
			// Configures the stage.
			
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			stage.addEventListener(Event.RESIZE, stage_onResize);
			
			// Builds the component.
			
			component = new class_();
			
			component.width = stage.stageWidth;
			component.height = stage.stageHeight;
			
			var flashvars:Object = LoaderInfo(this.root.loaderInfo).parameters;
			
			for (var key:Object in flashvars)
			{
				if (component.hasOwnProperty(key))
				{
					if (flashvars[key] == "false") flashvars[key] = false;
					
					component[key] = flashvars[key];
				}
				else
				{
					trace("Property '" + key + "' not found.");
				}
			}
			
			addChild(component);
		}
		
		private function stage_onResize(event:Event):void
		{
			component.width = Stage(event.currentTarget).stageWidth;
			component.height = Stage(event.currentTarget).stageHeight;
		}
	}
}